DCMTK: DiARGBImage Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Attributes | List of all members
DiARGBImage Class Reference

Class for ARGB images. More...

Inheritance diagram for DiARGBImage:

## Public Member Functions
| DiARGBImage (const DiDocument *docu, const EI_Status status)
| constructor
virtual | ~DiARGBImage ()
| destructor
virtual int | processNextFrames (const unsigned long fcount)
| process next couple of frames
Public Member Functions inherited from DiColorImage
| DiColorImage (const DiDocument *docu, const EI_Status status, const int spp, const OFBool rgb=OFTrue)
| constructor
virtual | ~DiColorImage ()
| destructor
virtual EP_Interpretation | getInternalColorModel () const
| get color model of internal pixel representation.
virtual unsigned long | getOutputDataSize (const int bits=0) const
| get number of bytes required for the rendered output of a single frame
const void * | getOutputData (const unsigned long frame, const int bits, const int planar=0)
| get pixel data with specified format.
int | getOutputData (void *buffer, const unsigned long size, const unsigned long frame, const int bits, const int planar=0)
| get pixel data with specified format.
const void * | getOutputPlane (const int plane) const
| get pixel data of specified plane.
void | deleteOutputData ()
| delete internally handled output memory buffer Save memory if data is no longer needed.
DiImage * | createImage (const unsigned long fstart, const unsigned long fcount) const
| create copy of current image object
DiImage * | createScale (const signed long left_pos, const signed long top_pos, const unsigned long src_cols, const unsigned long src_rows, const unsigned long dest_cols, const unsigned long dest_rows, const int interpolate, const int aspect, const Uint16 pvalue) const
| create scaled copy of specified (clipping) area of the current image object.
int | flip (const int horz, const int vert)
| flip current image (horizontally and/or vertically)
DiImage * | createFlip (const int horz, const int vert) const
| create a flipped copy of the current image
int | rotate (const int degree)
| rotate current image (by steps of 90 degrees)
DiImage * | createRotate (const int degree) const
| create a rotated copy of the current image.
DiImage * | createMono (const double red, const double green, const double blue) const
| create monochrome copy of the current image
const DiPixel * | getInterData () const
| get pointer to intermediate pixel data representation
const DiColorPixel * | getColorInterData () const
| get pointer to intermediate pixel data representation
unsigned long | createDIB (void *&data, const unsigned long size, const unsigned long frame, const int bits, const int upsideDown, const int padding=1)
| create true color (24/32 bit) bitmap for MS Windows.
unsigned long | createAWTBitmap (void *&data, const unsigned long frame, const int bits)
| create true color (32 bit) bitmap for Java (AWT default format).
int | writeImageToDataset (DcmItem &dataset, const int mode, const int planar)
| write current image and related attributes to DICOM dataset.
int | writePPM (STD_NAMESPACE ostream &stream, const unsigned long frame, const int bits)
| write pixel data to PPM file.
int | writePPM (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to PPM file.
int | writeRawPPM (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to raw PPM file
int | writeBMP (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to BMP file
Public Member Functions inherited from DiImage
| DiImage (const DiDocument *docu, const EI_Status status, const int spp)
| constructor
virtual | ~DiImage ()
| destructor
EI_Status | getStatus () const
| get status of the image object
Uint32 | getNumberOfFrames () const
| get number of frames
Uint32 | getFirstFrame () const
| get index of first frame
Uint32 | getTotalNumberOfFrames () const
| get total number of frames
Uint32 | getRepresentativeFrame () const
| get representative frame
double | getFrameTime () const
| get frame time
Uint16 | getRows () const
| get number of rows
Uint16 | getColumns () const
| get number of columns
double | getPixelWidth () const
| get pixel's width
double | getPixelHeight () const
| get pixel's height
double | getRowColumnRatio () const
| get pixel's rows/column ratio
double | getColumnRowRatio () const
| get pixel's column/rows ratio
int | setRowColumnRatio (const double ratio)
| set pixel's rows/column ratio
int | setColumnRowRatio (const double ratio)
| set pixel's column/rows ratio
EP_Polarity | getPolarity () const
| get polarity.
int | setPolarity (const EP_Polarity polarity)
| set polarity.
virtual int | getBits (const int bits=0) const
| get number of bits per sample.
virtual DiOverlay * | getOverlayPtr (const unsigned int)
| get pointer to the object managing the overlay planes
virtual DiMonoImage * | getMonoImagePtr ()
| get pointer to monochrome image object
int | writeFrameToDataset (DcmItem &dataset, const unsigned long frame=0, const int bits=0, const int planar=0)
| render pixel data of given frame and write image related attributes to DICOM dataset.

## Protected Member Functions
void | Init ()
| initialize internal data structures and member variables
Protected Member Functions inherited from DiColorImage
| DiColorImage (const DiColorImage *image, const unsigned long fstart, const unsigned long fcount)
| constructor, copy
| DiColorImage (const DiColorImage *image, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const int interpolate=0, const int aspect=0)
| constructor, scale/clip
| DiColorImage (const DiColorImage *image, const int horz, const int vert)
| constructor, flip
| DiColorImage (const DiColorImage *image, const int degree)
| constructor, rotate
int | checkInterData (const int mode=1)
| check intermediate pixel representation for consistency
const void * | getData (void *buffer, const unsigned long size, const unsigned long frame, const int bits, const int planar)
| get pixel data with specified format.
virtual void | updateImagePixelModuleAttributes (DcmItem &dataset)
| update Image Pixel Module attributes in the given dataset.
Protected Member Functions inherited from DiImage
| DiImage (const DiDocument *docu, const EI_Status status)
| constructor
| DiImage (const DiImage *image, const unsigned long fstart, const unsigned long fcount)
| constructor, copy
| DiImage (const DiImage *image, const Uint16 width, const Uint16 height, const int aspect=0)
| constructor, scale/clip
| DiImage (const DiImage *image, const int degree=0)
| constructor, rotate
| DiImage (const DiImage *image, const unsigned long frame, const int stored, const int alloc)
| constructor, createMonoOutput
void | deleteInputData ()
| delete internally handled object for the input pixel data conversion
void | checkPixelExtension ()
| check and possibly correct values for pixel spacing, aspect ratio etc.
void | convertPixelData ()
| create input pixel data representation from DICOM dataset structures
int | detachPixelData ()
| detach pixel data.

## Private Attributes
DiLookupTable * | Palette [3]
| three color palettes for R, G and B

## Additional Inherited Members
Protected Attributes inherited from DiColorImage
const OFBool | RGBColorModel
| flag, indicating whether the intermediate representation uses the RGB color model
DiColorPixel * | InterData
| points to intermediate pixel data representation (object)
Protected Attributes inherited from DiImage
EI_Status | ImageStatus
| copy of status variable declared in class 'DicomImage'
const DiDocument * | Document
| points to special object, which encapsulates the dcmdata module
Uint32 | FirstFrame
| first frame to be processed
Uint32 | NumberOfFrames
| number of frames in case of multi-frame images (otherwise '1')
Uint32 | TotalNumberOfFrames
| total number of frames stored in the dataset
Uint32 | RepresentativeFrame
| number of representative frame, type 3 attribute (default '0')
double | FrameTime
| nominal time between individual frames (0 if absent)
Uint16 | Rows
| number of rows (in pixel)
Uint16 | Columns
| number of columns (in pixel)
double | PixelWidth
| width of each pixel according to 'PixelSpacing/AspectRatio'
double | PixelHeight
| height of each pixel according to 'PixelSpacing/AspectRatio'
Uint16 | BitsAllocated
| number of bits allocated for each pixel
Uint16 | BitsStored
| number of bits stored for each pixel (see 'BitsPerSample')
Uint16 | HighBit
| position of highest stored bit
int | BitsPerSample
| actual number of bits per sample (depth)
int | SamplesPerPixel
| number of samples per pixel (1, 3 or 4)
EP_Polarity | Polarity
| polarity (normal or reverse)
int | hasSignedRepresentation
| is 'true' if pixel data is signed
int | hasPixelSpacing
| is 'true' if attribute 'PixelSpacing' is present
int | hasImagerPixelSpacing
| is 'true' if attribute 'ImagerPixelSpacing' is present
int | hasNominalScannedPixelSpacing
| is 'true' if attribute 'hasNominalScannedPixelSpacing' is present
int | hasPixelAspectRatio
| is 'true' if attribute 'PixelAspectRatio' is present
int | isOriginal
| is 'false' if derived from original image data (e.g. scaled)
DiInputPixel * | InputData
| points to intermediate pixel representation (template object)
DcmFileCache | FileCache
| file cache object used for partial read
Uint32 | CurrentFragment
| current pixel item fragment (for encapsulated pixel data)

## Detailed Description

Class for ARGB images.

## Constructor & Destructor Documentation

## ◆ DiARGBImage()

DiARGBImage::DiARGBImage | ( | const DiDocument * | docu,
|  | const EI_Status | status )

constructor

Parameters

  docu | pointer to dataset (encapsulated)
  status | current image status

## Member Function Documentation

## ◆ processNextFrames()

virtual int DiARGBImage::processNextFrames | ( | const unsigned long | fcount | ) |
| virtual

process next couple of frames

Parameters

  fcount | number of frames to be processed (0 = same number as before)

Returns
  status, true if successful, false otherwise

Reimplemented from DiImage.

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/diargimg.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2